﻿:Namespace Application ⍝ load and start application
    
    Abstract←'A simple address book'
    
   ⍝ root of application is filepath of workspace or .dyapp file
    Root←{⍵↓⍨1-'\'⍳⍨⌽⍵}⎕WSID{⍺≢'CLEAR WS':⍺ ⋄ ⍵}#.GetEnvironment'dyapp'
    
    MANIFEST←'common\'∘,¨'Clock' 'ISerialise' 'Serialise' 'Tools'
    MANIFEST,←⊂'GUI'
    MANIFEST,←'people\'∘,¨'Address' 'AddressBook' 'Person' 'Contact'
    
    ∇ Start;module;∆
     
      Abstract                                                      ⍝ introduce
     
     ⍝ load modules
      ∆←''
      :For module :In MANIFEST                                      ⍝ loop for debugging
          ∆,←⊂⎕SE.SALT.Load Root,'lib\',module
      :EndFor
      ⎕←{⍵[⍋↑⍵]}2↓∘⍕¨∆
     
     ⍝ initialise
      #.(Coord IconObj)←'Pixel'#.GUI.ICONS.dyalog
     
    ∇
    
    ∇ MAIN;F
      'F'⎕WC'Form'
      ⎕DQ #.Build.Application F ⍝ ... refactor as class derived from Form
    ∇
    
:EndNamespace ⍝ System